"""Middleware definitionsfor the mockstack app."""

import time

from fastapi import FastAPI, Request

from mockstack.config import Settings


def middleware_provider(app: FastAPI, settings: Settings) -> None:
    """Instrument the middlewares to the mockstack app."""

    @app.middleware("http")
    async def add_process_time_header(request: Request, call_next):
        start_time = time.time()
        response = await call_next(request)
        process_time = time.time() - start_time
        response.headers["X-Process-Time"] = str(process_time)
        return response
